angular.module('starter', ['ionic', 'starter.controllers', 'pascalprecht.translate', 'ui.router', 'ngCordova', 'ionicLazyLoad', 'ngIOS9UIWebViewPatch', 'ion-affix', 'ionic-letter-avatar']).run(function($ionicPlatform, $translate, $cordovaStatusbar) {
	$ionicPlatform.ready(function() {
		try {
			set_globalization($translate);
			$cordovaStatusbar.overlaysWebView(true);
			$cordovaStatusbar.style(1);
			start_promote();
		} catch(e) {
			alert(e);
		}
	});
}).config(function($stateProvider, $urlRouterProvider, $translateProvider, $ionicConfigProvider) {
	ionicConfigProvider = $ionicConfigProvider;
	$ionicConfigProvider.tabs.position('bottom');
	start_app($translateProvider);
	$stateProvider.state('app', {
		url : '/app',
		abstract : true,
		templateUrl : 'templates/menu.html',
		controller : 'AppCtrl'
	}).state('app.home', {
		url : '/home',
		views : {
			'menuContent' : {
				templateUrl : 'templates/home.html',
				controller : 'homeCtrl'
			}
		}
	}).state('app.mind', { 
			url : '/mind/:param1',
		views : {
			'menuContent' : {
				templateUrl : 'templates/mind.html',
				controller : 'mindCtrl'
			}
		}
	}).state('app.settings', {
		url : '/settings',
		views : {
			'menuContent' : {
				templateUrl : 'templates/settings.html',
				controller : 'settingsCtrl'
			}
		}
	}).state('app.bible', {
		url : '/bible',
		views : {
			'menuContent' : {
				templateUrl : 'templates/bible.html',
				controller : 'bibleCtrl'
			}
		}
	}).state('app.verses', {
		url : '/verses',
		views : {
			'menuContent' : {
				templateUrl : 'templates/verses.html',
				controller : 'versesCtrl'
			}
		}
	}).state('app.favorite', {
		url : '/favorite',
		views : {
			'menuContent' : {
				templateUrl : 'templates/favorite.html',
				controller : 'favoriteCtrl'
			}
		}
	});
	// if none of the above states are matched, use this as the fallback
	///var curr_sp = get_current_airport_name_key();
	$urlRouterProvider.otherwise('/app/home');
}).directive('ngEnter', function() {
	return function(scope, element, attrs) {
		element.bind("keydown keypress", function(event) {
			if (event.which === 13) {
				scope.$apply(function() {
					scope.$eval(attrs.ngEnter);
				});
				event.preventDefault();
			}
		});
	};
});
;
