angular.module('starter.controllers', []).controller('AppCtrl', function($ionicNavBarDelegate, $ionicViewSwitcher, $scope, $ionicModal, $timeout, $ionicPlatform, $state, $ionicSideMenuDelegate, $window, $ionicHistory, $ionicSlideBoxDelegate, $timeout, $http, $ionicScrollDelegate, $ionicPopup, $ionicLoading, $sce) {
	try {
		$scope.appData = {};
		$scope.need_buy = function(event) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				purchase_now($ionicPopup, $scope, get_inap_product_id());
			} catch(e) {
				log_msg(e);
			}
		}
		$scope.load_bible = function() {
			try {
				$scope.show();
				$scope.appData.bible = [];
				$scope.appData.bibleselected = get_data_obj_real('bible_selected');
				if (is_empty($scope.appData.bibleselected)) {
					var bibledata = get_bible_data();
					$scope.appData.bibleselected = bibledata[0];
				}
				var file_name = $scope.appData.bibleselected.filename;
				var url = "data/bible/" + file_name;
				$http.get(url).then(function(resp) {
					try {
						var bible_data = {};
						bible_data.b = resp.data;
						for (var b = 0; b < bible_data.b.length; b++) {
							if (!bible_data.b[b].c.length) {
								var cobj = [];
								cobj.push(bible_data.b[b].c);
								bible_data.b[b].c = cobj;
							}
							for (var c = 0; c < bible_data.b[b].c.length; c++) {
								if (!bible_data.b[b].c[c].v.length) {
									var vobj = [];
									vobj.push(bible_data.b[b].c[c].v);
									bible_data.b[b].c[c].v = vobj;
								}
							}
						}

						$scope.appData.bible = bible_data;
						set_verse_noti($scope);
						//$scope.$apply();
						$scope.hide();
					} catch(e) {
						$scope.hide();
						log_msg(e);
					}
				}, function(err) {
					$scope.hide();
					log_msg(err, $ionicPopup);
				});

			} catch(e) {
				$scope.hide();
				log_msg(e);
			}
		}
		$scope.sharethisapp = function(event) {
			try {
				var msg = "Download the App " + get_app_name() + ": " + get_app_download_url();
				if (device.platform.toLowerCase() == 'ios') {
					var targetRect = event.target.getBoundingClientRect(), targetBounds = targetRect.left + ',' + targetRect.top + ',' + targetRect.width + ',' + targetRect.height;
					window.plugins.socialsharing.setIPadPopupCoordinates(targetBounds);
				}
				window.plugins.socialsharing.share(msg);
			} catch(e) {
				log_msg(e);
			}
		}
		$scope.open_pop = function(key) {
			try {
				var url = '';
				switch(key) {
				case "web": {
					url = get_website_url();
					break;
				}
				case "facebook": {
					url = get_facebook_url();
					break;
				}
				case "twitter": {
					url = get_twitter_url();
					break;
				}
				case "linkedin": {
					url = get_linkedin_url();
					break;
				}
				case "youtube": {
					url = get_youtube_url();
					break;
				}
				}
				if (is_empty(url))
					url = get_website_url();
				open_browser(url);
			} catch(ee) {
				log_msg(ee);
			}
		};
		//---
		$ionicModal.fromTemplateUrl('templates/contactus.html', {
			scope : $scope,
			animation : 'slide-in-up'
		}).then(function(modal) {
			$scope.modal1 = modal;
		});
		$scope.openModal1 = function() {
			try {
				$scope.modal1.show();
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.closeModal1 = function() {
			$scope.modal1.hide();
		};
		$scope.report_send = function() {
			try {
				if (is_empty($scope.feedbackData.feedback_comment)) {
					alert_msg(get_key('pls_comment'), $ionicPopup);
					return;
				}
				var msg = $scope.feedbackData.feedback_comment;
				var sub = get_app_name() + "";
				window.plugins.socialsharing.shareViaEmail(msg, sub, [get_support_email()], // TO: must be null or an array
				[
				], // CC: must be null or an array
				null, // BCC: must be null or an array
				[
				], // FILES: can be null, a string, or an array
				function(succ) {
					$scope.closeModal1();
				}, function(err) {
				});
			} catch(e) {
				log_msg(e);
			}
		};
		//--

		$scope.show_contact = function(key) {
			try {
				$scope.feedbackData = {};
				$scope.feedbackData.showmaphelp = false;
				$scope.feedbackData.feedback_email = "";
				$scope.feedbackData.feedback_contact = "";
				if (key == "feedback") {
					$scope.feedbackData.feedback_heading = get_key("show_contact");
					$scope.feedbackData.feedback_comment = "";
				} else if (key == "moreapps") {
					open_browser(get_more_apps_url());
					return;
				} else if (key == "review") {
					open_browser(get_store_url());
					return;
				}
				$scope.openModal1();
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.show = function() {
			try {
				$ionicLoading.show({
					template : get_key('loading')
				});
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.hide = function() {
			try {
				$ionicLoading.hide();
			} catch(e) {
				log_msg(e);
			}
		};
		$ionicPlatform.ready(function() {
			try {
				$scope.appData = {};
				$scope.appData.is_paid = get_data_obj_real('is_paid');
				if (is_empty($scope.appData.is_paid))
					$scope.appData.is_paid = false;
				set_current_langauge($scope);
				handle_promote($ionicPopup);
				handlenoti();

				if (window.Connection) {
					if (navigator.connection.type == Connection.NONE) {
						//alert_msg(get_key('http_error'), $ionicPopup);
					} else {
						if (!$scope.appData.is_paid)
							ad_mob();
					}
				}
				$scope.load_bible();
			} catch(e) {
				log_msg(e);
			}
		});
	} catch(e) {
		log_msg(e);
	}
}).controller('settingsCtrl', function($scope, $ionicPlatform, $http, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $state, $ionicModal, $window, $cordovaGeolocation) {
	try {
		$scope.settingsData = {};

		$scope.settings_restore_purchase = function() {
			restore_pur($ionicPopup, $scope);
		};
		$scope.settings_changelang = function(lang) {
			try {
				set_current_language_key(lang);
				$window.location.reload(true);
			} catch(ee) {
				log_msg(ee);
			}
		};
		$scope.settings_noti_save = function() {
			try {
				set_data_obj_real('verse_reminder_selected', $scope.settingsData.verse_rem_selected);
				if (is_empty($scope.settingsData.verse_rem_time)) {
					alert_msg(get_key('enter_noti_time'), $ionicPopup);
					return;
				}
				var date_str = $scope.settingsData.verse_rem_time.toString('dd-MMM-yyyy HH:mm');
				set_data_obj_real('verse_reminder_time', date_str);
				set_verse_noti($scope);
				alert_msg(get_key('saved'), $ionicPopup);
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.settings_noti_change = function() {
			try {
				if (!$scope.settingsData.verse_rem_selected) {
					cancel_verse_noti();
				}
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.settings_changetrans = function(item) {
			try {
				set_data_obj_real('bible_selected', item);
				$scope.load_bible();
			} catch(e) {
				log_msg(e);
			}
		};
		$ionicPlatform.ready(function() {
			show_interstitial($scope);
			$scope.settingsData.bibles = get_bible_data();
			var bible_selected = get_data_obj_real('bible_selected');
			if (is_empty(bible_selected.filename))
				$scope.settingsData.bible_selected = $scope.settingsData.bibles[0];
			else {
				for (var i = 0; i < $scope.settingsData.bibles.length; i++) {
					if ($scope.settingsData.bibles[i].filename == bible_selected.filename) {
						$scope.settingsData.bible_selected = $scope.settingsData.bibles[i];
						break;
					}
				}
			}

			$scope.settingsData.verse_rem_selected = get_data_obj_real('verse_reminder_selected');
			if (is_empty($scope.settingsData.verse_rem_selected))
				$scope.settingsData.verse_rem_selected = false;

			var date_str = get_data_obj_real('verse_reminder_time');
			if (is_empty(date_str)) {
				var date2 = new Date();
				date2.setHours(9);
				date2.setMinutes(0);
				date_str = date2.toString('dd-MMM-yyyy HH:mm');
			}
			$scope.settingsData.verse_rem_time = new Date(date_str);

			$scope.settingsData.langall = [];
			var item = {};
			item.text = get_language_name_en();
			item.value = "en";
			$scope.settingsData.langall.push(item);

			item = {};
			item.text = get_language_name_ar();
			item.value = "ar";
			$scope.settingsData.langall.push(item);

			var curr_lang = get_current_language_key();
			for (var i = 0; i < $scope.settingsData.langall.length; i++) {
				if ($scope.settingsData.langall[i].value == curr_lang) {
					$scope.settingsData.SelectedLang = $scope.settingsData.langall[i];
					break;
				}
			}

		});
	} catch(e) {
		log_msg(e);
	}
}).controller('favoriteCtrl', function($scope, $timeout, $ionicPlatform, $http, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $state, $ionicModal, $window, $cordovaGeolocation) {
	try {
		$scope.favoriteData = {};
		$scope.favorite_sharecode = function() {
			try {
				var item = $scope.favoriteData.biblefavs[$scope.favoriteData.curr_fav_idx];
				var msg = get_verse_text_bible($scope.appData.bible, item.b, item.c, item.v);
				share_code_bible(msg);
			} catch(e) {
				log_msg(e);
			}
		}
		$scope.favorite_fav = function(is_fav1, item1) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				var item = $scope.favoriteData.biblefavs[$scope.favoriteData.curr_fav_idx];
				rem_from_fav_bible(item);
				$scope.favoriteData.biblefavs.splice($scope.favoriteData.curr_fav_idx, 1);
				$ionicSlideBoxDelegate.update();

				var idx = $scope.favoriteData.curr_fav_idx - 1;
				if (idx < 0)
					idx = 0;
				$timeout(function() {
					$ionicSlideBoxDelegate.$getByHandle('favoriteSlideDirective').slide(idx);
				}, 500);
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.favorite_day_night = function(flag, event) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				$scope.favoriteData.curr_is_day = flag;
				if ($scope.favoriteData.curr_is_day) {
					set_data_obj_real('curr_is_day_favorite', 'Y');
					$scope.favoriteData.curr_bg_color = "white";
					$scope.favoriteData.curr_font_color = "black";
				} else {
					set_data_obj_real('curr_is_day_favorite', 'N');
					$scope.favoriteData.curr_bg_color = "black";
					$scope.favoriteData.curr_font_color = "white";
				}

			} catch(ee) {
				log_msg(ee);
			}
		};
		$scope.favorite_resize = function(flag, event) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				var par = $scope.favoriteData.curr_font_size;
				if (flag)
					par++;
				else
					par--;
				if (par < 0)
					par = 0;
				if (par > 10)
					par = 10;
				$scope.favoriteData.curr_font_size = par;
				set_data_obj_real('curr_font_size_favorite', $scope.favoriteData.curr_font_size);
			} catch(ee) {
				log_msg(ee);
			}
		};
		$scope.favorite_speak = function(flag, event) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				$scope.favoriteData.speaking = flag;
				if ($scope.favoriteData.biblefavs.length == 0)
					return;
				if (flag) {
					var item = $scope.favoriteData.biblefavs[$scope.favoriteData.curr_fav_idx];
					var txt = $scope.appData.bible.b[item.b].c[item.c].v[item.v].text;
					TTS.speak({
						text : txt,
						rate : 1.50
					}, function() {
						//$scope.favoriteData.speaking = false;
					}, function(reason) {
						//$scope.favoriteData.speaking = false;
					});
				} else {
					TTS.speak({
						text : '',
						rate : 1.50
					}, function() {
						//$scope.favoriteData.speaking = false;
					}, function(reason) {
						//$scope.favoriteData.speaking = false;
					});
				}
			} catch(ee) {
				log_msg(ee);
			}
		};

		$scope.favorite_slideHasChanged = function(idx) {
			try {
				show_interstitial($scope);
				$ionicScrollDelegate.scrollTop();
				$scope.favoriteData.curr_fav_idx = idx;
				if ($scope.favoriteData.speaking)
					$scope.favorite_speak($scope.favoriteData.speaking, null);
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.favorite_refresh = function() {
			try {
				$scope.favoriteData.curr_font_size = get_data_obj_real('curr_font_size_favorite');
				if (is_empty($scope.favoriteData.curr_font_size))
					$scope.favoriteData.curr_font_size = 5;

				var curr_is_day = get_data_obj_real('curr_is_day_favorite');
				if (is_empty(curr_is_day))
					curr_is_day = 'Y';
				if (curr_is_day == 'Y')
					$scope.favoriteData.curr_is_day = true;
				else
					$scope.favoriteData.curr_is_day = false;

				if ($scope.favoriteData.curr_is_day) {
					$scope.favoriteData.curr_bg_color = "white";
					$scope.favoriteData.curr_font_color = "black";
				} else {
					$scope.favoriteData.curr_bg_color = "black";
					$scope.favoriteData.curr_font_color = "white";
				}
				$scope.favoriteData.speaking = false;
				$scope.favoriteData.biblefavs = get_data_obj_real("favsbible");
				$scope.favoriteData.biblefavs = set_arr($scope.favoriteData.biblefavs);

				$scope.favoriteData.curr_fav_idx = 0;
				$ionicSlideBoxDelegate.update();
				$timeout(function() {
					$ionicSlideBoxDelegate.$getByHandle('favoriteSlideDirective').slide(0);
				}, 500);
				//	$scope.$apply();
			} catch(e) {
				log_msg(e);
			}
		};
		$ionicPlatform.ready(function() {
			try {
				$scope.favoriteData.slideHeight = window.innerHeight * .50;
				$scope.favoriteData.is_loading = true;
				$scope.$on('$ionicView.enter', function() {
					show_interstitial($scope);
					if ($scope.favoriteData.is_loading) {
						$scope.favoriteData.is_loading = false;
						return;
					}
					$scope.favorite_refresh();
				});
				$scope.favorite_refresh();
			} catch(e) {
				log_msg(e);
			}
		});
	} catch(e) {
		log_msg(e);
	}
}).controller('versesCtrl', function($scope, $timeout, $ionicPlatform, $http, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $state, $ionicModal, $window, $cordovaGeolocation) {
	try {
		$scope.versesData = {};
		$scope.verses_sharecode = function(verse) {
			try {
				var msg = "\"" + verse.text + "\" " + verse.bname + ' ' + verse.c + ':' + verse.v;
				//	var msg = get_verse_text_bible($scope.versesData.bible, $scope.versesData.curr_book_idx, $scope.versesData.curr_chapter_idx, $scope.versesData.curr_verse_idx);
				share_code_bible(msg);
			} catch(e) {
				log_msg(e);
			}
		}
		$scope.verses_fav = function(is_fav1, item1) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				var item = {};
				item.b = item1.b - 1;
				item.c = item1.c - 1;
				item.v = item1.v - 1;
				if (is_fav1)
					add_to_fav_bible(item);
				else
					rem_from_fav_bible(item);
				item1.is_fav = is_fav1;
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.verses_day_night = function(flag, event) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				$scope.versesData.curr_is_day = flag;
				if ($scope.versesData.curr_is_day) {
					set_data_obj_real('curr_is_day_verses', 'Y');
					$scope.versesData.curr_bg_color = "white";
					$scope.versesData.curr_font_color = "black";
				} else {
					set_data_obj_real('curr_is_day_verses', 'N');
					$scope.versesData.curr_bg_color = "black";
					$scope.versesData.curr_font_color = "white";
				}

			} catch(ee) {
				log_msg(ee);
			}
		};
		$scope.verses_resize = function(flag, event) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				var par = $scope.versesData.curr_font_size;
				if (flag)
					par++;
				else
					par--;
				if (par < 0)
					par = 0;
				if (par > 10)
					par = 10;
				$scope.versesData.curr_font_size = par;
				set_data_obj_real('curr_font_size_verses', $scope.versesData.curr_font_size);
			} catch(ee) {
				log_msg(ee);
			}
		};
		$scope.verses_speak = function(flag, event) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				$scope.versesData.speaking = flag;
				if (flag) {
					var txt = $scope.versesData.bible[$scope.versesData.curr_verse_idx1].text;
					TTS.speak({
						text : txt,
						rate : 1.50
					}, function() {
						//$scope.versesData.speaking = false;
					}, function(reason) {
						//$scope.versesData.speaking = false;
					});
				} else {
					TTS.speak({
						text : '',
						rate : 1.50
					}, function() {
						//$scope.versesData.speaking = false;
					}, function(reason) {
						//$scope.versesData.speaking = false;
					});
				}
			} catch(ee) {
				log_msg(ee);
			}
		};
		$scope.verses_is_contains = function(verse, value) {
			try {
				if (is_empty(value))
					return true;
				var msg = "\"" + verse.text + "\" " + verse.bname + ' ' + verse.c + ':' + verse.v;
				var is_cont = is_contains(msg.toLowerCase(), value.toLowerCase());
				return is_cont;
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.verses_slideHasChanged = function(idx) {
			try {
				show_interstitial($scope);
				if (isNaN(idx)) {
					return;
				}
				$ionicScrollDelegate.scrollTop();
				$scope.versesData.curr_verse_idx1 = idx;
				if ($scope.versesData.speaking)
					$scope.verses_speak($scope.versesData.speaking, null);
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.verses_search = function() {
			try {
				$scope.versesData.search_text1 = $scope.versesData.search_text;
				$scope.verses_refresh();

			} catch(e) {
				log_msg(e);
			}
		};

		$scope.verses_refresh = function() {
			var item = {};
			try {
				$scope.show();
				$scope.versesData.refresh_finished = false;
				$scope.versesData.curr_font_size = get_data_obj_real('curr_font_size_verses');
				if (is_empty($scope.versesData.curr_font_size))
					$scope.versesData.curr_font_size = 5;

				var curr_is_day = get_data_obj_real('curr_is_day_verses');
				if (is_empty(curr_is_day))
					curr_is_day = 'Y';
				if (curr_is_day == 'Y')
					$scope.versesData.curr_is_day = true;
				else
					$scope.versesData.curr_is_day = false;

				if ($scope.versesData.curr_is_day) {
					$scope.versesData.curr_bg_color = "white";
					$scope.versesData.curr_font_color = "black";
				} else {
					$scope.versesData.curr_bg_color = "black";
					$scope.versesData.curr_font_color = "white";
				}
				$scope.versesData.speaking = false;

				$scope.versesData.bible = [];
				var count = 0;
				var max_verses = 50;
				var bible = JSON.parse(JSON.stringify($scope.appData.bible));
				bible.b = shuffle(bible.b);
				for (var b = 0; b < bible.b.length; b++) {
					if (count > max_verses)
						break;
					bible.b[b].c = shuffle(bible.b[b].c);
					for (var c = 0; c < bible.b[b].c.length; c++) {
						if (count > max_verses)
							break;
						bible.b[b].c[c].v = shuffle(bible.b[b].c[c].v);
						for (var v = 0; v < bible.b[b].c[c].v.length; v++) {
							if (count > max_verses)
								break;
							var item = {};
							item.bname = bible.b[b].name;
							item.b = b;
							item.c = c;
							item.v = v;
							item.b = parseInt(bible.b[b].n);
							item.c = parseInt(bible.b[b].c[c].n);
							item.v = parseInt(bible.b[b].c[c].v[v].n);
							item.text = bible.b[b].c[c].v[v].text;
							item.is_fav = is_fav_bible(item);

							if (!is_empty($scope.versesData.search_text1)) {
								var msg = "\"" + item.text + "\" " + item.bname + ' ' + item.c + ':' + item.v;
								var is_cont = is_contains(msg.toLowerCase(), $scope.versesData.search_text1.toLowerCase());
								if (!is_cont) {
									continue;
								}
							}
							$scope.versesData.bible.push(item);
							count++;
						}
					}
				}
				$scope.versesData.curr_verse_idx1 = 0;
				$ionicSlideBoxDelegate.update();
				$scope.versesData.refresh_finished = true;
				$ionicSlideBoxDelegate.$getByHandle('versesSlideDirective').slide(0);
				//	$scope.$apply();
				$scope.hide();
			} catch(e) {
				$scope.hide();
				log_msg(e);
			}
		};
		$ionicPlatform.ready(function() {
			try {
				$scope.versesData.search_text = '';
				$scope.versesData.search_text1 = '';
				$scope.versesData.slideHeight = window.innerHeight * .35;
				$scope.versesData.is_loading = true;

				$scope.$on('$ionicView.enter', function() {
					show_interstitial($scope);
					if ($scope.versesData.is_loading) {
						$scope.versesData.is_loading = false;
						return;
					}
					$scope.verses_refresh();
				});
				$scope.verses_refresh();

			} catch(e) {
				log_msg(e);
			}
		});
	} catch(e) {
		log_msg(e);
	}
}).controller('bibleCtrl', function($scope, $timeout, $ionicPlatform, $http, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $state, $ionicModal, $window, $cordovaGeolocation) {
	try {
		$scope.bibleData = {};
		$scope.bible_day_night = function(flag, event) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				$scope.bibleData.curr_is_day = flag;
				if ($scope.bibleData.curr_is_day) {
					set_data_obj_real('curr_is_day', 'Y');
					$scope.bibleData.curr_bg_color = "white";
					$scope.bibleData.curr_font_color = "black";
				} else {
					set_data_obj_real('curr_is_day', 'N');
					$scope.bibleData.curr_bg_color = "black";
					$scope.bibleData.curr_font_color = "white";
				}

			} catch(ee) {
				log_msg(ee);
			}
		};
		$scope.bible_resize = function(flag, event) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				var par = $scope.bibleData.curr_font_size;
				if (flag)
					par++;
				else
					par--;
				if (par < 0)
					par = 0;
				if (par > 10)
					par = 10;
				$scope.bibleData.curr_font_size = par;
				set_data_obj_real('curr_font_size', $scope.bibleData.curr_font_size);
			} catch(ee) {
				log_msg(ee);
			}
		};
		$scope.bible_speak = function(flag, event) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				$scope.bibleData.speaking = flag;
				if (flag) {
					var verses_arr = $scope.appData.bible.b[$scope.bibleData.curr_book_idx].c[$scope.bibleData.curr_chapter_idx].v;
					var txt = '';
					for (var i = 0; i < verses_arr.length; i++) {
						txt += verses_arr[i].text + ' ';
					}

					///alert($scope.bibleData.curr_book_idx + ',' + $scope.bibleData.curr_chapter_idx);
					TTS.speak({
						text : txt,
						rate : 1.50
					}, function() {
						//$scope.bibleData.speaking = false;
					}, function(reason) {
						//$scope.bibleData.speaking = false;
					});
				} else {
					TTS.speak({
						text : '',
						rate : 1.50
					}, function() {
						//$scope.bibleData.speaking = false;
					}, function(reason) {
						//$scope.bibleData.speaking = false;
					});
				}
			} catch(ee) {
				log_msg(ee);
			}
		};
		//----FILTER----
		$ionicModal.fromTemplateUrl('templates/bible_filter_chapter.html', {
			scope : $scope
		}).then(function(modal) {
			$scope.bible_modalfilter_chapter = modal;
		});
		$scope.bible_close_filter_chapter_from_page = function() {
			$scope.bible_refresh();
			$scope.bible_modalfilter_chapter.hide();
		};
		$scope.bible_close_filter_chapter = function() {
			$scope.bible_modalfilter_chapter.hide();
		};
		$scope.bible_open_filter_chapter = function() {
			try {
				$scope.bible_modalfilter_chapter.show();
			} catch(ee) {
				log_msg(ee);
			}
		};
		$scope.bible_load_from_filter_chapter = function(idx) {
			try {
				$scope.bibleData.curr_chapter_idx = idx;
				set_data_obj_real('curr_chapter_idx', $scope.bibleData.curr_chapter_idx);
				$scope.bible_close_filter_chapter();
				$scope.bible_refresh();

			} catch(ee) {
				log_msg(ee);
			}
		};
		//------------
		//----FILTER----
		$ionicModal.fromTemplateUrl('templates/bible_filter.html', {
			scope : $scope
		}).then(function(modal) {
			$scope.bible_modalfilter = modal;
		});
		$scope.bible_close_filter = function() {
			$scope.bible_modalfilter.hide();
		};
		$scope.bible_open_filter = function() {
			try {
				$scope.bible_modalfilter.show();
			} catch(ee) {
				log_msg(ee);
			}
		};
		$scope.bible_load_from_filter = function(indx) {
			try {
				$scope.bibleData.curr_book_idx = indx;
				set_data_obj_real('curr_book_idx', $scope.bibleData.curr_book_idx);
				$scope.bible_close_filter();
				$scope.bibleData.curr_chapter_idx = 0;
				set_data_obj_real('curr_chapter_idx', $scope.bibleData.curr_chapter_idx);
				//alert($scope.appData.bible.b[$scope.bibleData.curr_book_idx].c.length);
				$scope.bible_open_filter_chapter();
			} catch(ee) {
				log_msg(ee);
			}
		};
		//------------
		$scope.bible_slideHasChanged = function(idx) {
			try {
				show_interstitial($scope);
				$ionicScrollDelegate.scrollTop();
				$scope.bibleData.curr_chapter_idx = idx;
				set_data_obj_real('curr_chapter_idx', $scope.bibleData.curr_chapter_idx);
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.bible_refresh = function() {
			try {
				$scope.bibleData.curr_book_idx = get_data_obj_real('curr_book_idx');
				if (is_empty($scope.bibleData.curr_book_idx))
					$scope.bibleData.curr_book_idx = 0;
				$scope.bibleData.curr_chapter_idx = get_data_obj_real('curr_chapter_idx');
				if (is_empty($scope.bibleData.curr_chapter_idx))
					$scope.bibleData.curr_chapter_idx = 0;

				$scope.bibleData.curr_font_size = get_data_obj_real('curr_font_size');
				if (is_empty($scope.bibleData.curr_font_size))
					$scope.bibleData.curr_font_size = 5;

				var curr_is_day = get_data_obj_real('curr_is_day');
				if (is_empty(curr_is_day))
					curr_is_day = 'Y';
				if (curr_is_day == 'Y')
					$scope.bibleData.curr_is_day = true;
				else
					$scope.bibleData.curr_is_day = false;

				if ($scope.bibleData.curr_is_day) {
					$scope.bibleData.curr_bg_color = "white";
					$scope.bibleData.curr_font_color = "black";
				} else {
					$scope.bibleData.curr_bg_color = "black";
					$scope.bibleData.curr_font_color = "white";
				}
				//$scope.bibleData.title = $scope.appData.bible.b[$scope.bibleData.curr_book_idx].n;
				$scope.bibleData.speaking = false;
				$ionicSlideBoxDelegate.update();

				$timeout(function() {
					$ionicSlideBoxDelegate.$getByHandle('bibleSlideDirective').slide($scope.bibleData.curr_chapter_idx);
				}, 2000);
				///$scope.$apply();
			}
			catch(e) {
				log_msg(e);
			}
		};
		$ionicPlatform.ready(function() {
			try {
				$scope.bibleData.is_loading = true;
				$scope.$on('$ionicView.enter', function() {
					show_interstitial($scope);
					if ($scope.bibleData.is_loading) {
						$scope.bibleData.is_loading = false;
						return;
					}
					$scope.bible_refresh();
				});
				$scope.bible_refresh();
			} catch(e) {
				log_msg(e);
			}
		});
	} catch(e) {
		log_msg(e);
	}
}).controller('mindCtrl', function($scope, $stateParams, $ionicPlatform, $http, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $state, $ionicModal, $window, $cordovaGeolocation) {
	try {
		$scope.mindData = {};
		//----FILTER----
		$ionicModal.fromTemplateUrl('templates/mind_filter.html', {
			scope : $scope
		}).then(function(modal) {
			$scope.mind_modalfilter = modal;
		});
		$scope.mind_close_filter = function() {
			$scope.mind_modalfilter.hide();
		};
		$scope.mind_open_filter = function() {
			try {
				$scope.mind_modalfilter.show();
			} catch(ee) {
				log_msg(ee);
			}
		};

		//------------
		$scope.mind_on_touch = function() {
			$scope.mindData.press_status = 'touch';
			$scope.mind_load_on_touch();
		};
		$scope.mind_on_release = function() {
			$scope.mindData.press_status = 'released';
		};
		$scope.mind_load_on_touch = function() {
			try {
				var item = $scope.mindData.verses[Math.floor(Math.random() * $scope.mindData.verses.length)];
				$scope.mindData.verse_rand = item;
				$scope.mindData.verse_rand_show = get_verse_text_bible($scope.appData.bible, item.b, item.c, item.v);
				var sz = parseFloat(window.innerWidth) / parseFloat($scope.mindData.verse_rand_show.length);
				sz *= 16.10;
				$scope.mindData.font_size = sz;
				//alert(sz);
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.mind_change_mind = function() {
			$scope.mind_open_filter();
		};
		$scope.mind_change_pfor = function(type) {
			try {
				$scope.mindData.type = type;
				$ionicScrollDelegate.scrollTop();
				//$scope.mind_refresh();
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.mind_load_from_filter = function(item, index) {
			if (!$scope.appData.is_paid) {
				if (index > 0) {
					$scope.need_buy(event);
					return;
				}
			}
			$scope.mind_close_filter();
			$scope.mindData.item = item;
			$scope.mind_refresh();
		};
		$scope.mind_sharecode = function(event, item) {
			try {
				var msg = get_verse_text_bible($scope.appData.bible, item.b, item.c, item.v);
				share_code_bible(msg);
			} catch(e) {
				log_msg(e);
			}
		}
		$scope.mind_fav = function(is_fav1, item1, event) {
			try {
				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
				var item = {};
				item.b = parseInt(item1.b);
				item.c = parseInt(item1.c);
				item.v = parseInt(item1.v);
				if (is_fav1)
					add_to_fav_bible(item);
				else
					rem_from_fav_bible(item);

				for (var i = 0; i < $scope.mindData.verses.length; i++) {
					if ($scope.mindData.verses[i].b == item1.b && $scope.mindData.verses[i].c == item1.c && $scope.mindData.verses[i].v == item1.v) {
						$scope.mindData.verses[i].is_fav = is_fav1;
						break;
					}
				}
				item1.is_fav = is_fav1;
			} catch(e) {
				log_msg(e);
			}
		};
		$scope.mind_refresh = function() {
			try {
				$ionicScrollDelegate.scrollTop();
				$scope.mindData.press_status = 'none';
				$scope.mindData.title = $scope.mindData.item.name;
				var url = "data/mind/" + $scope.mindData.item.key + ".xml";
				$http.get(url).then(function(resp) {
					try {
						var x2js = new X2JS();
						var jsonData = x2js.xml_str2json(resp.data);
						var this_arr = jsonData.loc.object;
						this_arr = set_arr(this_arr);
						this_arr = shuffle(this_arr);
						var this_arr_new = [];
						var miss_cunt = 0;
						for (var i = 0; i < this_arr.length; i++) {
							if (i > 25)
								break;
							//jso(this_arr[i]);
							this_arr[i].b = parseInt(this_arr[i]._b) - 1;
							this_arr[i].c = parseInt(this_arr[i]._c) - 1;
							this_arr[i].v = parseInt(this_arr[i]._v) - 1;
							this_arr[i].is_fav = is_fav_bible(this_arr[i]);
							this_arr[i].verse_rand_show = get_verse_text_bible($scope.appData.bible, this_arr[i].b, this_arr[i].c, this_arr[i].v);
							if (is_empty(this_arr[i].verse_rand_show)) {
								miss_cunt++;
								continue;
							}
							this_arr_new.push(this_arr[i]);
							if (miss_cunt > 0) {
								log_msg('missing ' + miss_cunt + ' field(s)');
							}
						}
						$scope.mindData.verses = this_arr_new;
						//$scope.mindData.verses = shuffle($scope.mindData.verses);
					} catch(e) {
						log_msg(e);
					}
				}, function(err) {
					log_msg(err, $ionicPopup);
				});

			} catch(e) {
				log_msg(e);
			}
		};
		$ionicPlatform.ready(function() {
			try {
				$scope.mindData.verses = [];
				$scope.mindData.slide_height = window.innerHeight * .30;
				$scope.mindData.touch_width = window.innerWidth * .25;
				$scope.mindData.mind_items = get_mind_array();
				$scope.mindData.item = JSON.parse($stateParams.param1);
				$scope.mindData.type = 'say';
				$scope.mindData.is_loading = true;
				$scope.$on('$ionicView.enter', function() {
					show_interstitial($scope);
					if ($scope.mindData.is_loading) {
						$scope.mindData.is_loading = false;
						return;
					}
					$scope.mind_refresh();
				});
				$scope.mind_refresh();
			} catch(e) {
				log_msg(e);
			}
		});
	} catch(e) {
		log_msg(e);
	}
}).controller('homeCtrl', function($scope, $ionicPlatform, $http, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $state, $ionicModal, $window, $cordovaGeolocation) {
	try {
		$scope.homeData = {};
		$scope.home_open_bbv = function() {
			try {
				$state.go('app.verses');
			} catch(e) {
				alert(e);
			}
		};
		$scope.home_open_bb = function() {
			try {
				$state.go('app.bible');
			} catch(e) {
				alert(e);
			}
		};
		$scope.home_open_item = function(item, index, event) {
			try {
				if (!$scope.appData.is_paid) {
					if (index > 0) {
						$scope.need_buy(event);
						return;
					}
				}
				$state.go('app.mind', {
					param1 : JSON.stringify(item)
				});
			} catch(e) {
				alert(e);
			}
		};

		$scope.home_loadmind = function() {
			try {
				$scope.homeData.mind = get_mind_array();
				$ionicSlideBoxDelegate.update();

			} catch(e) {
				log_msg(e);
			}
		};
		$ionicPlatform.ready(function() {
			show_interstitial($scope);
			$scope.home_loadmind();
		});
	} catch(e) {
		log_msg(e);
	}
});
