function purchase_now(ionicPopup, scope, productId) {
	try {
		var productIds = [];
		scope.show();
		productIds.push(productId);
		inAppPurchase.getProducts(productIds).then(function(products) {
			scope.hide();
			var got_product = false;
			for (var i = 0; i < products.length; i++) {
				if (products[i].productId == productId) {
					got_product = true;
					var msg_title = get_key('unlock');
					var msg_desc = get_key('unlock_desc');
					msg_desc = msg_desc.replace("abcdefg", products[i].price);
					var confirmPopup = ionicPopup.confirm({
						title : msg_title,
						template : msg_desc,
						buttons : [{
							text : get_key("later"),
							onTap : function(res) {
								return false;
							}
						}, {
							text : get_key("get_now"),
							type : 'button-energized',
							onTap : function(res) {
								return true;
							}
						}]
					});
					confirmPopup.then(function(res) {
						try {
							if (res) {
								inAppPurchase.buy(productId).then(function(data) {
									make_purchased(scope);
									//alert_msg(get_key('success_purchase'), ionicPopup);
								}).catch(function(err) {
									alert_msg(err.errorMessage);
								});
							}
						} catch(e) {
							log_msg(e);
						}
					});
					break;
				}
			}

			if (!got_product) {
				alert_msg(get_key('failed_inapp'), ionicPopup);
				return;
			}
		}).catch(function(err) {
			scope.hide();
			alert_msg(err.errorMessage);
		});
	} catch(e) {
		scope.hide();
		log_msg(e);
	}
}

function restore_pur(ionicPopup, scope) {
	try {
		//alert('restoring...');
		//	scope.appData.is_paid = false;
		//set_data_obj_real('is_paid', false);
		var stat = '';
		var stat_ok = '';
		var count = -1;
		scope.show();
		inAppPurchase.restorePurchases().then(function(purchases) {
			try {
				scope.hide();
				var is_buy = false;
				for (var i = 0; i < purchases.length; i++) {
					var pid = purchases[i].productId;
					if (pid == get_inap_product_id()) {
						make_purchased(scope);
						is_buy = true;
					}
				}
				if (is_buy) {
					alert_msg(get_key('pur_rest_succ'), ionicPopup);
				} else {
					alert_msg(get_key('pur_rest_fail'), ionicPopup);
				}
			} catch(e) {
				scope.hide();
				log_msg(e);
			}
		}).catch(function(err) {
			scope.hide();
			log_msg(err);
		});
	} catch(e) {
		scope.hide();
		log_msg(e);
	}
}
